import EditCompany from "./add/index.vue";
import EditExpired from "./expired/index.vue";

export const columns = (search, disable, enable, updateExpired, updateCompany) => [
  {
    title: "企业名称",
    key: "name",
    align: "center",
    minWidth: 60,
    render: (h, { row }) => {
      return h(EditCompany, {
        props: { dataSource: row },
        on: { search }
      });
    }
  },
  {
    title: "企业简称",
    key: "abbr",
    align: "center",
    minWidth: 60,
  },
  {
    title: "地址",
    key: "address",
    align: "center",
    minWidth: 60,
  },
  {
    title: "联系人",
    key: "contectName",
    align: "center",
    minWidth: 60,
  },
  {
    title: "联系电话",
    key: "contectPhone",
    align: "center",
    minWidth: 60,
  },
  {
    title: "有效期",
    key: "expiredDate",
    align: "center",
    minWidth: 60,
  },
  {
    title: "省",
    key: "province",
    align: "center",
    minWidth: 60,
  },
  {
    title: "市",
    key: "city",
    align: "center",
    minWidth: 60,
  },
  {
    title: "区",
    key: "district",
    align: "center",
    minWidth: 60,
  },
  {
    title: "状态",
    align: "center",
    minWidth: 60,
    render(h, { row }) {
      try {
        const { status } = row;
        return h("span", {style: {color: status == 1 ? 'green' : 'red' }}, status == 1 ? '有效' : '失效');
      } catch(e) {
        console.log(e);
      }
    }
  },
  {
    title: "操作",
    align: "center",
    fixed: 'right',
    width: 180,
    render(h, { row }) {
      try {
        const { status } = row;
        var emptyTag = h("span","　");

        var disableTag = h(
            "Poptip",
            {
                props: { title: "确定停用当前帐号吗？", transfer: true, confirm: true, size: "small" },
                on: { "on-ok": () => { row.status=0; disable(row); } }
            },
            [
                h("Button", {props: {type: "error", size: "small"}}, "停用")
            ]
        );
        var enableTag = h(
            "Button",
            {
                props: { type: "primary", size: "small" },
                on: { click: () => { row.status=1; enable(row); }}
            },
            "启用"
        );
        var updateExpiredTag = h(EditExpired, {
          props: { dataSource: row },
          on: { search }
        });
        
        return h("span", status == 1 ? [updateExpiredTag, emptyTag, disableTag] : [enableTag]);
      } catch(e) {
        console.log(e);
      }
    }
  },
];
