import store from "@/store";
const { dispatch } = store;
import { columns } from "./helper.js";
import EditCompany from "./add/index.vue";

export default {
  components: { EditCompany },
  data() {
    return {
      loading: false,
      columns: [], 
      name: "",

      changeCurrent: 1,
      data: {
        total:0,
        current: 1,
        records:[],
      },
      page: {
        size: 10,
      },
    }
  },
  methods: {
    disable(company) {
      dispatch("invoke/asyncUpdateCompanyStatus", company);
    },
    enable(company) {
      dispatch("invoke/asyncUpdateCompanyStatus", company);
    },
    updateExpired(company) {
      dispatch("invoke/asyncUpdateCompanyExpired", company);
    },
    updateCompany(company) {
      dispatch("invoke/asyncUpdateCompany", company);
    },
    search(current = 1) {  
      this.searchForm = {
          name: this.name
      };

      this.loading = true
      const initQuery = {
        current,
        size: this.page.size,
        records: this.searchForm
      };
      dispatch("invoke/asyncListCompany", {
        ...initQuery
      }).then(({ data }) => {
        this.loading = false
        if (data != null) {
          this.data = {...data};
        } else {
          this.data = {
            total:0,
            current: 1,
            records:[],
          };
        }
        // console.log(this.data)
      });
    },
    changePage(current) {
      this.search(current);
      this.changeCurrent = current
    },
    changeSize(value) { 
      this.page.size = value
      this.search();
    },
  },
  mounted() {
    this.columns = columns(this.search, this.disable, this.enable, this.updateExpired, this.updateCompany);
    this.search();
  }
};
